package com.prosperolambda.android.app.hecate;

import android.content.Context;
import android.content.SharedPreferences;
import android.preference.PreferenceManager;
import android.util.Log;

public class UrgenciaDispatcher {
	
	private final static UrgenciaDispatcher INSTANCE= new UrgenciaDispatcher();
	private final static String TAG="UrgenciaDispatcher";
	
	private boolean mbSms;
	private boolean mbDebug;
	private String msNumero;
	private float mfPrecision;
	private double[] mdPosicion;
	private Context mContext;
	private IUrgencia mUrgencia;
	
	private UrgenciaDispatcher(){
		mContext=null;
		mUrgencia=null;
		mdPosicion=null;
		mbSms=false;
		mbDebug=false;
		msNumero=null;		
		mfPrecision=0.0f;
	}
	
	public void activarEmergencia(){
		mdPosicion= GpsControl.getInstance().getPosicion();
		mfPrecision=GpsControl.getInstance().getPrecision();
		SharedPreferences preferencias=null;		
		try{
			preferencias= PreferenceManager.getDefaultSharedPreferences( getContext() );
		
		msNumero= preferencias.getString("opciones_telefono", "112");
		mbDebug= preferencias.getBoolean("opciones_debug", false);
		mbSms= preferencias.getBoolean("opciones_sms", false);
		
		}catch(NullPointerException e){
			e.printStackTrace();
			Log.e(TAG, "Contexto no iniciado!");
		}
		
		Log.d(TAG, "Debug: "+mbDebug);
		Log.d(TAG, "Sms: "+mbSms);
		Log.d(TAG, "Telefono: "+msNumero);
		Log.d(TAG, "Coordenadas: "+mdPosicion[0]+" "+mdPosicion[1]);
		Log.d(TAG, "Precision: "+mfPrecision);
		
		//Si el mtodo de aviso elegido es SMS...
		if(mbSms){
			mUrgencia=new SmsUrgencia();		
		}
		else{
			mUrgencia=new LlamadaUrgencia();
		}
	
		//Activa el mtodo anteriormente escogido
		mUrgencia.activarUrgencia();
	}
	
	public static UrgenciaDispatcher getInstance(){
		Log.d(TAG, "Devolviendo instancia de UrgenciaDispatcher");
		return INSTANCE;
	}
	
	public Context getContext(){
		return mContext;
	}
	
	public void setContext(Context e){
		mContext=e;
	}
	
	public boolean getDebug(){
		return mbDebug;
	}
	
	public boolean getSms(){
		return mbSms;
	}
	
	public double[] getPosicion(){
		return mdPosicion;
	}
	
	public float getPrecision(){
		return mfPrecision;
	}
	
	public String getNumero(){
		return msNumero;
	}

}
